#!/usr/bin/env ruby -I..
#
# $Idaemons: /home/cvs/pkgtools/tests/test_portsdb.rb,v 1.3 2001/10/09 20:13:17 knu Exp $

require 'runit/testcase'
require 'runit/cui/testrunner'

require 'pkgdb'
require 'portsdb'

class TestPortsDB < RUNIT::TestCase
  def test_strip
    pkgdb = PkgDB.instance.setup('/var/db/pkg')
    portsdb = PortsDB.instance.setup(pkgdb.db_dir, '/usr/ports')

    assert_equal('foo/bar1', portsdb.strip('foo/bar1'))
    assert_equal('foo/bar2', portsdb.strip('foo/bar2/'))
    assert_equal('foo/bar3', portsdb.strip('/usr/ports/foo/bar3'))
    assert_equal('foo/bar4', portsdb.strip('/usr/ports/foo/bar4/'))
    assert_equal('foo/bar7', portsdb.strip('/usr/ports/foo//bar7/'))
    assert_equal(nil, portsdb.strip('/usr/ports/foo/../bar8/foo/'))
    assert_equal(nil, portsdb.strip('/usr/ports/foo/./bar9/'))
    assert_equal(nil, portsdb.strip('/usr/ports/foo/bar5/Makefile'))
    assert_equal(nil, portsdb.strip('/usr/ports/foo/bar6/files/'))
    assert_equal(nil, portsdb.strip('/foo'))
    assert_equal(nil, portsdb.strip('/foo/'))
    assert_equal(nil, portsdb.strip('/foo/bar'))
  end
end

if $0 == __FILE__
  suite = RUNIT::TestSuite.new

  suite.add_test(TestPortsDB.suite)

  RUNIT::CUI::TestRunner.run(suite)
end
